`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:31:56 08/15/2016 
// Design Name: 
// Module Name:    constFFT 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module constFFT(
    output [39:0] cval
    );

/* From bit accurate model: */
//0010 1010 1010 0010 0010 0010 0000 0001 1111 1000
//0010 0000 1010 0010 1010 1010 0000 0010 0110 0000
//VERY GOOD: int scaling_sch[stages] = { 1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1 }; = 0x155111 rev(0x2222AA >> 1)

//the best:  int scaling_sch[stages] = { 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 1 }; = 0x155141 rev(0x20A2AA >> 1)

//int scaling_sch[stages] =            { 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0 }; = final!

//bad, but need to try:
//scaling_sch[stages] = { 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 0 };
//int scaling_sch[stages] = { 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 0 }; = 0x08A2AA


//0x20a2aa >> 1   = shift(2138794; −1) = 0x105155 = 0001 0000 0101 0001 0101 0101

//ORIGINAL, used up to firmware dated 05.08.2017:
//assign cval = 40'h08A2AA01F8; //sometimes in rare cases fft overflow happens
assign cval = 40'h02A2AA01F8; //lower power but no fft overflow
endmodule
