

#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>

#define IS_CIF963


typedef struct {
	ap_uint<8> data;
	ap_uint<1>  last;
} u8stream;

/**************************************************************************************************
 * THIS WORKS FINE, but needs BRAM optimizations!
 **************************************************************************************************/
void convolution_dbg(hls::stream<u8stream > &input, hls::stream<u8stream > &output, ap_uint<2> *debug);


const static unsigned char PARITY_0[] = {
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    1, 0, 0, 1, 0, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1,
    0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0
};


int do_convolution(uint8_t *in, int in_size, uint8_t *out, int out_size)
{
    size_t in_block_size = in_size;
    size_t out_block_size = (in_size * 4) + 3;
    size_t in_offset = 0;
    size_t out_offset = 0;
    unsigned short memory = 0;
    unsigned char data;

    // While there is enought input and ouput items
    while (in_size - in_offset >= in_block_size &&
            out_size - out_offset >= out_block_size) {
        for (size_t in_count = 0; in_count < in_block_size; ++in_count) {
            data = in[in_offset];
            //PDEBUG("Input: 0x%x\n", data);
            // For next 4 output bytes
            for (unsigned out_count = 0; out_count < 4; ++out_count) {
                out[out_offset] = 0;
                // For each 4-bit output word
                for (unsigned j = 0; j < 2; ++j) {
                    memory >>= 1;
                    memory |= (data >> 7) << 6;
                    data <<= 1;
                    //PDEBUG("Memory: 0x%x\n", memory);
                    unsigned char poly[4] = {
                        (unsigned char)(memory & 0x5b),
                        (unsigned char)(memory & 0x79),
                        (unsigned char)(memory & 0x65),
                        (unsigned char)(memory & 0x5b)
                    };
                    //PDEBUG("Polys: 0x%x, 0x%x, 0x%x, 0x%x\n", poly[0], poly[1], poly[2], poly[3]);
                    // For each poly
                    for (unsigned k = 0; k < 4; ++k) {
                        out[out_offset] <<= 1;
                        out[out_offset] |= PARITY_0[poly[k]];
                        //PDEBUG("Out bit: %i\n", out[no] >> 7);
                    }
                }
                //PDEBUG("Out: 0x%x\n", out[no]);
                ++out_offset;
            }
            ++in_offset;
        }
        for (unsigned pad_count = 0; pad_count < 3; ++pad_count) {
            out[out_offset] = 0;
            // For each 4-bit output word
            for (unsigned j = 0; j < 2; ++j) {
                memory >>= 1;
                //PDEBUG("Memory: 0x%x\n", memory);
                unsigned char poly[4] = {
                    (unsigned char)(memory & 0x5b),
                    (unsigned char)(memory & 0x79),
                    (unsigned char)(memory & 0x65),
                    (unsigned char)(memory & 0x5b)
                };
                //PDEBUG("Polys: 0x%x, 0x%x, 0x%x, 0x%x\n", poly[0], poly[1], poly[2], poly[3]);
                // For each poly
                for (unsigned k = 0; k < 4; ++k) {
                    out[out_offset] <<= 1;
                    out[out_offset] |= PARITY_0[poly[k]];
                    //PDEBUG("Out bit: %i\n", out[no] >> 7);
                }
            }
            //PDEBUG("Out: 0x%x\n", out[no]);
            ++out_offset;
        }
    }
}

#if 1
uint8_t conv_in_FIC1[96] = {
0x01, 0xbc, 0xec, 0x5c, 0x13, 0x9d, 0x85, 0xc9, 0x98, 0x15, 0x33, 0xb1, 0x53, 0x88, 0x80,
0xa2, 0xa3, 0xf7, 0x02, 0xf5, 0x0c, 0x29, 0xbf, 0x11, 0x23, 0x8d, 0xf3, 0x25, 0xb5, 0xd9, 0x3c,
0xbd, 0xce, 0x94, 0x69, 0x7f, 0x45, 0x8e, 0xb2, 0xcf, 0x1f, 0x74, 0x1a, 0xdb, 0xb0, 0x5a, 0xfa,
0xa8, 0x14, 0xaf, 0x2e, 0xe0, 0x73, 0xa4, 0xf5, 0xd4, 0x48, 0x67, 0x0b, 0xdb, 0x34, 0x3b, 0x6b,
0x56, 0xf0, 0x7c, 0x5c, 0xc8, 0x25, 0x3b, 0x47, 0x9f, 0x36, 0x2a, 0x47, 0x1b, 0x57, 0x13, 0x11,
0x00, 0x84, 0x61, 0x39, 0x56, 0x1b, 0xd3, 0x72, 0x28, 0x56, 0x9f, 0xb2, 0x4b, 0x7e, 0x4d, 0xe4,
0x68
};
uint8_t conv_out_FIC1[387] = {
0x00, 0x00, 0x00, 0x0f, 0x9b, 0xf6, 0xff, 0xbb, 0x6d, 0x29, 0xdf, 0xf6, 0x04, 0x0d, 0x46,
0xfd, 0x64, 0x60, 0x6d, 0x2b, 0xd9, 0x29, 0xd2, 0x9d, 0xff, 0x60, 0xb9, 0x92, 0x46, 0xfd, 0x92,
0xbd, 0xb2, 0xf0, 0x2d, 0xff, 0xb6, 0xff, 0x62, 0xb0, 0x20, 0xb4, 0x2f, 0x02, 0x29, 0xdf, 0xf6,
0x04, 0x0d, 0xb0, 0x20, 0xb4, 0xd9, 0x26, 0xb0, 0x2d, 0xdf, 0x2d, 0x29, 0xf0, 0xf6, 0x2b, 0xf4,
0x2f, 0xdb, 0x02, 0x04, 0x20, 0xb9, 0xb2, 0x2b, 0x00, 0x0d, 0x64, 0x6f, 0xf6, 0x24, 0x60, 0xb4,
0xf6, 0xd0, 0x4d, 0x66, 0xb0, 0xfb, 0x99, 0x2b, 0xfb, 0x42, 0x06, 0xff, 0x42, 0x24, 0x9b, 0x02,
0xdd, 0xf2, 0x24, 0x42, 0xd0, 0xb6, 0x26, 0xbf, 0x4f, 0x6f, 0xf4, 0xd4, 0x6d, 0xdf, 0x0d, 0xbd,
0x4b, 0xb9, 0x69, 0x09, 0x69, 0x29, 0xf2, 0xff, 0x6f, 0xdb, 0xdb, 0xd6, 0x4b, 0x62, 0x4b, 0x60,
0xb4, 0x00, 0x0d, 0x9d, 0x29, 0xd0, 0x94, 0xbb, 0x4f, 0x42, 0x04, 0xf9, 0x64, 0xbb, 0xb6, 0x04,
0x2d, 0x2b, 0xf9, 0xb2, 0xfd, 0x49, 0x90, 0x4f, 0xb6, 0xd0, 0x62, 0x69, 0xfd, 0x4b, 0x99, 0xf2,
0x26, 0x4b, 0x9b, 0xfb, 0x9b, 0xdb, 0x00, 0x02, 0x09, 0xbd, 0x90, 0x9b, 0xf9, 0x92, 0x66, 0x90,
0x99, 0xf0, 0x2f, 0xf6, 0x0b, 0x60, 0x62, 0x49, 0x66, 0x92, 0x90, 0x4d, 0xbf, 0x6d, 0xf2, 0xf2,
0x04, 0xd9, 0xff, 0x62, 0xbf, 0xbb, 0xb4, 0x0d, 0x90, 0xbb, 0x62, 0x4b, 0x6f, 0x2f, 0x00, 0xd6,
0x46, 0xff, 0x94, 0x62, 0x9d, 0x29, 0xd0, 0x94, 0xb4, 0xdb, 0xd6, 0x44, 0xf6, 0x29, 0xf2, 0x06,
0xd0, 0x42, 0xf2, 0x24, 0x42, 0x26, 0x6b, 0x00, 0x22, 0x92, 0x64, 0x99, 0x24, 0x60, 0xb4, 0x0f,
0x99, 0x06, 0xf2, 0xd0, 0x96, 0xbd, 0x66, 0x46, 0xdf, 0xf9, 0x90, 0x96, 0x92, 0x66, 0x69, 0xdf,
0xd6, 0x69, 0xff, 0xbb, 0x94, 0x60, 0x94, 0x9b, 0xd4, 0x9b, 0x0d, 0x46, 0xfd, 0x9d, 0xdf, 0x0d,
0xb2, 0x29, 0x06, 0xd2, 0x4b, 0x4f, 0xb4, 0xd9, 0xdf, 0xf9, 0x66, 0xb2, 0x0b, 0x94, 0xb6, 0xd2,
0x6b, 0xd4, 0x6d, 0xd0, 0x60, 0x60, 0x40, 0xdb, 0x02, 0x0b, 0xb4, 0x2d, 0x0b, 0x62, 0x6b, 0xf4,
0xf6, 0x09, 0x69, 0xdf, 0xd9, 0xfd, 0x6b, 0x02, 0x2b, 0x2f, 0xf4, 0x02, 0xdd, 0xf2, 0xd2, 0x9f,
0x00, 0xf6, 0xdd, 0x26, 0x9d, 0xdd, 0x04, 0x0f, 0xb9, 0x9d, 0x2b, 0xd9, 0x29, 0x24, 0x40, 0x2f,
0xd6, 0x90, 0xb9, 0x6b, 0xf6, 0xff, 0xb4, 0xf9, 0x44, 0x20, 0x6f, 0x0d, 0x92, 0xb2, 0xdf, 0xdb,
0xf4, 0xd6, 0x92, 0xb0, 0xd6, 0x66, 0x64, 0x4d, 0x6b, 0x22, 0xb0, 0xf6, 0xfd, 0xbd, 0x44, 0xd4,
0xbb, 0x96, 0x9f, 0xf4, 0x22, 0x46, 0x2b, 0xdb, 0x20, 0x6f, 0xfb, 0xb6, 0x2b, 0x2d, 0x04, 0xf9,
0x6b, 0xd9, 0xf0, 0x00
};
#endif
uint8_t conv_in_FIC2[96] = {
0x02, 0xbe, 0xe0, 0x71, 0x3d, 0x77, 0xa5, 0xcd, 0x59, 0x37, 0x22, 0x8d, 0xa1, 0x99, 0x89,
0x9d, 0x86, 0x20, 0x8d, 0x9f, 0x2e, 0xed, 0xb9, 0x37, 0x0d, 0x6b, 0xc9, 0x04, 0x4b, 0x36, 0xa6,
0x76, 0xce, 0x94, 0x69, 0x7f, 0x45, 0x8e, 0xb2, 0xcf, 0x1f, 0x74, 0x1a, 0xdb, 0xb0, 0x5a, 0xfa,
0xa8, 0x14, 0xaf, 0x2e, 0xe0, 0x73, 0xa4, 0xf5, 0xd4, 0x48, 0x67, 0x0b, 0xdb, 0x34, 0x3b, 0x6b,
0x56, 0xf0, 0x7c, 0x5c, 0xc8, 0x25, 0x3b, 0x47, 0x9f, 0x36, 0x2a, 0x47, 0x1b, 0x57, 0x13, 0x11,
0x00, 0x84, 0x61, 0x39, 0x56, 0x1b, 0xd3, 0x72, 0x28, 0x56, 0x9f, 0xb2, 0x4b, 0x7e, 0x4d, 0xe4,
0x68,
};
uint8_t conv_out_FIC2[387] = {
0x00, 0x00, 0x00, 0xf6, 0x2b, 0x0d, 0x90, 0x4d, 0xb0, 0x00, 0xd6, 0x46, 0xff, 0x94, 0x62,
0x6b, 0x02, 0x2b, 0xd6, 0x44, 0xf6, 0x29, 0xf2, 0xf0, 0xfb, 0x4f, 0x94, 0xbb, 0xb6, 0xfd, 0x9d,
0xd0, 0x99, 0xdf, 0xd6, 0x9f, 0xdb, 0xdb, 0x20, 0x6f, 0x0d, 0x92, 0xb2, 0xdf, 0xdb, 0xf4, 0x20,
0x4f, 0x60, 0x96, 0x6b, 0xd6, 0x6b, 0x00, 0x2d, 0xf0, 0x2d, 0xff, 0x40, 0x22, 0xb2, 0xf0, 0x22,
0x9d, 0xff, 0x60, 0xb9, 0x6b, 0x0f, 0x40, 0x2d, 0x29, 0x06, 0xdd, 0xd0, 0x4f, 0x60, 0x6f, 0x22,
0x6b, 0xd4, 0x62, 0x4b, 0x6f, 0x2f, 0x00, 0x2f, 0xf9, 0x90, 0x99, 0xf0, 0xd9, 0x2b, 0xdb, 0x20,
0x6f, 0x0d, 0x64, 0x96, 0xbf, 0x99, 0x26, 0x66, 0x92, 0x90, 0xbb, 0x62, 0xbd, 0x44, 0x22, 0x90,
0x6d, 0xdd, 0xf2, 0x24, 0xbb, 0x99, 0xf2, 0xd0, 0x60, 0x96, 0x9d, 0x0b, 0x42, 0xf0, 0x22, 0x9d,
0xff, 0x99, 0x06, 0xf2, 0x29, 0xd0, 0x94, 0xbb, 0x4f, 0x42, 0x04, 0xf9, 0x64, 0xbb, 0xb6, 0x04,
0x2d, 0x2b, 0xf9, 0xb2, 0xfd, 0x49, 0x90, 0x4f, 0xb6, 0xd0, 0x62, 0x69, 0xfd, 0x4b, 0x99, 0xf2,
0x26, 0x4b, 0x9b, 0xfb, 0x9b, 0xdb, 0x00, 0x02, 0x09, 0xbd, 0x90, 0x9b, 0xf9, 0x92, 0x66, 0x90,
0x99, 0xf0, 0x2f, 0xf6, 0x0b, 0x60, 0x62, 0x49, 0x66, 0x92, 0x90, 0x4d, 0xbf, 0x6d, 0xf2, 0xf2,
0x04, 0xd9, 0xff, 0x62, 0xbf, 0xbb, 0xb4, 0x0d, 0x90, 0xbb, 0x62, 0x4b, 0x6f, 0x2f, 0x00, 0xd6,
0x46, 0xff, 0x94, 0x62, 0x9d, 0x29, 0xd0, 0x94, 0xb4, 0xdb, 0xd6, 0x44, 0xf6, 0x29, 0xf2, 0x06,
0xd0, 0x42, 0xf2, 0x24, 0x42, 0x26, 0x6b, 0x00, 0x22, 0x92, 0x64, 0x99, 0x24, 0x60, 0xb4, 0x0f,
0x99, 0x06, 0xf2, 0xd0, 0x96, 0xbd, 0x66, 0x46, 0xdf, 0xf9, 0x90, 0x96, 0x92, 0x66, 0x69, 0xdf,
0xd6, 0x69, 0xff, 0xbb, 0x94, 0x60, 0x94, 0x9b, 0xd4, 0x9b, 0x0d, 0x46, 0xfd, 0x9d, 0xdf, 0x0d,
0xb2, 0x29, 0x06, 0xd2, 0x4b, 0x4f, 0xb4, 0xd9, 0xdf, 0xf9, 0x66, 0xb2, 0x0b, 0x94, 0xb6, 0xd2,
0x6b, 0xd4, 0x6d, 0xd0, 0x60, 0x60, 0x40, 0xdb, 0x02, 0x0b, 0xb4, 0x2d, 0x0b, 0x62, 0x6b, 0xf4,
0xf6, 0x09, 0x69, 0xdf, 0xd9, 0xfd, 0x6b, 0x02, 0x2b, 0x2f, 0xf4, 0x02, 0xdd, 0xf2, 0xd2, 0x9f,
0x00, 0xf6, 0xdd, 0x26, 0x9d, 0xdd, 0x04, 0x0f, 0xb9, 0x9d, 0x2b, 0xd9, 0x29, 0x24, 0x40, 0x2f,
0xd6, 0x90, 0xb9, 0x6b, 0xf6, 0xff, 0xb4, 0xf9, 0x44, 0x20, 0x6f, 0x0d, 0x92, 0xb2, 0xdf, 0xdb,
0xf4, 0xd6, 0x92, 0xb0, 0xd6, 0x66, 0x64, 0x4d, 0x6b, 0x22, 0xb0, 0xf6, 0xfd, 0xbd, 0x44, 0xd4,
0xbb, 0x96, 0x9f, 0xf4, 0x22, 0x46, 0x2b, 0xdb, 0x20, 0x6f, 0xfb, 0xb6, 0x2b, 0x2d, 0x04, 0xf9,
0x6b, 0xd9, 0xf0, 0x00,
};



uint8_t conv_in_CIF1[192] = {
0xf8, 0x42, 0x6a, 0xa0, 0xaf, 0x09, 0xf1, 0xeb, 0xab, 0x04, 0x32, 0x8f, 0xe2, 0x89, 0x88, 0x80,
0x42, 0x92, 0xae, 0x8c, 0x47, 0x83, 0xaf, 0xc2, 0x4a, 0x28, 0xb9, 0x53, 0xb6, 0x82, 0x20, 0x56,
0xef, 0x1e, 0x61, 0x9e, 0x37, 0x89, 0x16, 0xa2, 0x87, 0xaf, 0x68, 0xee, 0x54, 0xda, 0xa1, 0x64,
0xbb, 0xc9, 0x0c, 0x19, 0xd5, 0x05, 0x5d, 0x87, 0x91, 0x42, 0x3a, 0x45, 0x19, 0x3d, 0x79, 0x80,
0x63, 0x4d, 0x6a, 0x69, 0xa1, 0xe0, 0x1d, 0x59, 0x9c, 0xc7, 0x2c, 0x17, 0x1f, 0xc8, 0xb4, 0x99,
0x2d, 0x44, 0x28, 0xbb, 0x98, 0x49, 0x35, 0xa2, 0x67, 0x13, 0x61, 0x06, 0xbf, 0x7a, 0x8f, 0xa3,
0x05, 0x12, 0xc6, 0x8f, 0xc1, 0xb4, 0xd1, 0x24, 0x3c, 0xfc, 0xe3, 0x06, 0xcd, 0x36, 0xad, 0x3e,
0x61, 0x8b, 0x6c, 0x2c, 0xa2, 0x21, 0x46, 0x1b, 0xf2, 0x18, 0xab, 0xdf, 0xc6, 0xa2, 0xb4, 0x64,
0xc4, 0x94, 0xbd, 0x82, 0xaf, 0xda, 0x04, 0x04, 0xa0, 0x19, 0x4a, 0xbe, 0xac, 0xfd, 0x17, 0x0c,
0x63, 0x98, 0x89, 0x7d, 0xff, 0x75, 0xa9, 0xe0, 0xe0, 0x9b, 0xe4, 0x9e, 0x2a, 0x4f, 0x7d, 0x0e,
0x0a, 0xb3, 0x79, 0x8f, 0x54, 0x34, 0x33, 0x06, 0xb4, 0xa3, 0x3d, 0xb1, 0x95, 0xa1, 0xcf, 0xc8,
0x59, 0x8a, 0xae, 0xea, 0x94, 0xd3, 0xd7, 0x51, 0x21, 0x9c, 0x2f, 0x9b, 0x3f, 0x31, 0x1f, 0xfa,
};
uint8_t conv_out_CIF1[771] = {
0xf9, 0x49, 0xbd, 0x49, 0x49, 0x9d, 0xd2, 0x69, 0xd2, 0xb2, 0x09, 0x9d, 0xf2, 0xf2, 0x04, 0xd9,
0x06, 0x2b, 0x0d, 0x90, 0xbb, 0x94, 0x99, 0xd2, 0xbd, 0x6b, 0xd4, 0x9b, 0xfb, 0x94, 0x4f, 0x62,
0x9f, 0x20, 0x6d, 0xfd, 0x69, 0x0b, 0x60, 0x6d, 0xd2, 0x66, 0xb0, 0x0d, 0x44, 0xf4, 0x20, 0xb9,
0xb2, 0xd2, 0x49, 0xb0, 0xdb, 0xf4, 0x2f, 0x22, 0xb2, 0xff, 0x40, 0x2d, 0xdf, 0x2d, 0x29, 0xf0,
0x0f, 0x6d, 0xd2, 0x69, 0x2b, 0xfb, 0xb4, 0xd4, 0xb4, 0x02, 0xfd, 0x9f, 0x20, 0x9b, 0x20, 0x40,
0xf4, 0x02, 0xdd, 0x0b, 0x94, 0xb9, 0x46, 0x09, 0x46, 0xd0, 0x62, 0x90, 0x42, 0x24, 0x94, 0x99,
0xd2, 0x44, 0xd4, 0xb4, 0xf4, 0x2f, 0xdb, 0xf4, 0x2f, 0xd4, 0x6f, 0xd9, 0x24, 0x40, 0x20, 0xb4,
0xd9, 0xdf, 0xf9, 0x90, 0x96, 0x6b, 0xd9, 0x06, 0xdd, 0xdf, 0x2d, 0x29, 0xff, 0x62, 0xb0, 0xd6,
0x69, 0xf0, 0x2f, 0x0f, 0xbb, 0x9b, 0xfb, 0x94, 0xb6, 0xdd, 0xff, 0xb9, 0x6b, 0x00, 0x22, 0x64,
0xb9, 0xbf, 0x4f, 0x6f, 0xfb, 0xb9, 0xb0, 0x22, 0x44, 0x2d, 0xfd, 0x49, 0x66, 0x9d, 0x04, 0x2f,
0xdb, 0xf4, 0xd6, 0x64, 0x94, 0x4f, 0x62, 0x90, 0xb4, 0x0f, 0x96, 0x6b, 0x20, 0xb6, 0xdf, 0x00,
0xd9, 0x24, 0x40, 0x20, 0xb4, 0x20, 0x60, 0x96, 0x9d, 0xf2, 0x04, 0xd6, 0x92, 0x49, 0x9f, 0xdb,
0xd4, 0xbb, 0x6f, 0x2f, 0x0f, 0xbb, 0x62, 0xbd, 0x44, 0x22, 0x66, 0xb0, 0xfb, 0x60, 0x9b, 0x00,
0x22, 0x9d, 0x06, 0xdf, 0x20, 0x4d, 0x90, 0x62, 0xb0, 0x2f, 0xd9, 0xf2, 0xff, 0x60, 0xb9, 0x64,
0x94, 0xb6, 0x2b, 0x2d, 0xfd, 0xbf, 0x4d, 0x69, 0xdd, 0xd0, 0xb6, 0xd0, 0x94, 0xb4, 0x2d, 0xfd,
0xbf, 0x42, 0x04, 0x00, 0xdb, 0xdb, 0xd6, 0x44, 0xf6, 0x29, 0x0b, 0xb6, 0xdd, 0xff, 0xb6, 0xf0,
0x0f, 0x9b, 0x0f, 0x4f, 0x4f, 0x96, 0x44, 0x20, 0x99, 0x26, 0x66, 0x9d, 0x0b, 0x42, 0x09, 0x64,
0x42, 0x09, 0x6b, 0xd6, 0x64, 0x94, 0xb9, 0x46, 0xf0, 0x0f, 0x94, 0x6d, 0x06, 0xdf, 0xd6, 0x9f,
0x2d, 0xf0, 0x22, 0x92, 0x9d, 0xdf, 0xf4, 0xfb, 0x62, 0x92, 0x4b, 0x99, 0x0b, 0x60, 0x62, 0x46,
0xfd, 0x6b, 0xfb, 0x9b, 0x2d, 0x24, 0x62, 0xb2, 0xdf, 0xd4, 0x96, 0x66, 0x4b, 0x4d, 0xb2, 0xf0,
0xdb, 0xd4, 0xbb, 0x96, 0x69, 0xd0, 0x42, 0xf2, 0xd2, 0x69, 0x2b, 0xf4, 0x2f, 0xd4, 0x6f, 0x2f,
0x00, 0xd9, 0xdd, 0xff, 0xb9, 0x9d, 0x24, 0x4d, 0x44, 0xdb, 0x20, 0x99, 0x26, 0x66, 0x6b, 0x2f,
0x22, 0xb2, 0xf0, 0x22, 0x92, 0x6b, 0x02, 0x2b, 0x20, 0x60, 0x60, 0xb9, 0x9d, 0xd2, 0x90, 0x9b,
0xf9, 0x92, 0x90, 0x42, 0x2b, 0x00, 0xfb, 0x4f, 0x6d, 0x04, 0x20, 0xb9, 0xbd, 0xbf, 0x9b, 0x20,
0x40, 0xfb, 0x60, 0x62, 0xbf, 0x42, 0xf2, 0x24, 0xbb, 0x99, 0x04, 0xf4, 0xf9, 0x6b, 0x20, 0xb9,
0xb2, 0x24, 0x94, 0x60, 0x9b, 0xf6, 0x09, 0x66, 0x44, 0x20, 0x96, 0xb2, 0xf2, 0x24, 0x4d, 0x44,
0x22, 0x66, 0x49, 0x4b, 0x6d, 0x26, 0xb2, 0x24, 0x6d, 0x29, 0x26, 0xbf, 0x40, 0xfb, 0x60, 0x9b,
0xf6, 0x06, 0xf2, 0xd0, 0x96, 0x44, 0x20, 0x60, 0x96, 0x9d, 0xfd, 0x66, 0x66, 0x44, 0xd6, 0xbd,
0x46, 0xdd, 0xff, 0xb9, 0x6b, 0x0f, 0x40, 0xd4, 0x96, 0x90, 0x99, 0x06, 0x0b, 0x99, 0x24, 0x99,
0xfd, 0x44, 0xf4, 0x2f, 0x2d, 0xdf, 0x2d, 0x26, 0x92, 0xbf, 0x42, 0x04, 0x0f, 0xb9, 0x6b, 0xf6,
0xff, 0x42, 0x24, 0x62, 0xb2, 0x26, 0x6b, 0x0f, 0x40, 0xdb, 0x02, 0xfd, 0x90, 0xb4, 0x00, 0xf4,
0x2d, 0x24, 0x9b, 0xf4, 0xf9, 0x9d, 0x04, 0x2f, 0xdb, 0x0d, 0x66, 0x66, 0xb2, 0x04, 0x00, 0xdb,
0xdb, 0x2f, 0xf4, 0x02, 0x24, 0x4d, 0x4b, 0x4f, 0xbb, 0xbb, 0x60, 0xb4, 0x0f, 0x60, 0xb6, 0x06,
0x2b, 0x02, 0xfd, 0x90, 0x42, 0x2b, 0x0f, 0x96, 0x6b, 0xd9, 0xff, 0x6d, 0xd2, 0x9f, 0x0f, 0x6d,
0x24, 0xb4, 0xf4, 0xd9, 0xf0, 0x0f, 0x9b, 0x00, 0xd4, 0x4f, 0xbb, 0xb4, 0x02, 0xfd, 0x90, 0x4d,
0xbf, 0x6d, 0xfd, 0x69, 0xf2, 0x26, 0xb2, 0x2b, 0xf9, 0xb2, 0xfd, 0x46, 0xfd, 0x64, 0x96, 0xb0,
0xf4, 0xf4, 0x0f, 0x4f, 0xb6, 0x29, 0xdd, 0xff, 0x40, 0x2d, 0xdf, 0x22, 0x4b, 0xb6, 0x04, 0xdb,
0x00, 0xf4, 0x2d, 0xdd, 0x2b, 0x00, 0x02, 0x06, 0x26, 0x66, 0x9d, 0x0b, 0x4d, 0x64, 0xb9, 0x46,
0x09, 0x46, 0x26, 0x46, 0x06, 0xd2, 0xb2, 0x06, 0xff, 0x4d, 0x46, 0x2b, 0xd4, 0x4d, 0xbd, 0x64,
0xb9, 0xb0, 0xdb, 0x02, 0x0b, 0xb4, 0xdb, 0xd6, 0x44, 0x00, 0xf4, 0xdb, 0xf9, 0xbd, 0x66, 0x46,
0x26, 0x46, 0x06, 0x2b, 0x02, 0xfd, 0x69, 0xf2, 0xd0, 0x6f, 0xfb, 0xb6, 0xdd, 0xff, 0x4f, 0xb9,
0x44, 0xf6, 0xdf, 0x20, 0x4d, 0x66, 0xbf, 0x96, 0xbd, 0x66, 0xb0, 0x02, 0xdf, 0xfb, 0x60, 0x9b,
0xf9, 0x92, 0x66, 0x66, 0x4b, 0xb4, 0xf4, 0x20, 0x40, 0x02, 0x26, 0x44, 0x0f, 0x99, 0x06, 0x04,
0xf4, 0x00, 0xd4, 0x40, 0xd6, 0x66, 0x6b, 0xd6, 0x64, 0x62, 0x9d, 0x26, 0xb2, 0x24, 0x62, 0xb2,
0x26, 0x92, 0x49, 0x9f, 0x2d, 0xff, 0x40, 0xdb, 0x02, 0xf2, 0xfd, 0x9f, 0x2f, 0x00, 0x20, 0x6d,
0xf2, 0x0b, 0xbb, 0x4f, 0xb4, 0x20, 0x96, 0x44, 0xd6, 0x44, 0xf6, 0x29, 0xf2, 0x06, 0xd0, 0x42,
0xf2, 0x24, 0x42, 0x26, 0x6b, 0x00, 0x22, 0x92, 0x64, 0x99, 0x24, 0x60, 0x4d, 0x46, 0xdd, 0x06,
0x06, 0xf2, 0x26, 0xb2, 0x24, 0x6d, 0xdf, 0xf4, 0x02, 0xdd, 0x0b, 0x9b, 0x2d, 0xdd, 0xd2, 0xbf,
0x9b, 0xd9, 0xf0,
};



uint8_t conv_in_CIF2[384] = {
0xf8, 0x42, 0xaa, 0x20, 0x85, 0x33, 0xc5, 0x9a, 0xce, 0x73, 0x41, 0x9c, 0xba, 0x9b, 0xc1, 0x80,
0x42, 0x30, 0x9c, 0x54, 0xa7, 0x19, 0x13, 0xbe, 0x81, 0xe5, 0x7b, 0xea, 0x93, 0xc3, 0xfd, 0x35,
0x87, 0x8c, 0x04, 0xca, 0x9b, 0xd3, 0x5a, 0x29, 0x95, 0x4d, 0xb8, 0x49, 0xfa, 0x72, 0x58, 0x21,
0xf3, 0x0d, 0xa7, 0x46, 0xed, 0xdd, 0x53, 0x4a, 0x3f, 0xf7, 0x98, 0x67, 0xb0, 0xa5, 0x6d, 0xc8,
0xa4, 0xf1, 0xed, 0x32, 0x59, 0x45, 0xda, 0x04, 0x2d, 0x1c, 0x71, 0xa9, 0x7d, 0x88, 0x73, 0xb4,
0x09, 0x02, 0x23, 0x3c, 0xc4, 0xe0, 0x24, 0xd1, 0x8d, 0xab, 0x44, 0x86, 0x43, 0xb5, 0xe5, 0xbe,
0x49, 0x6f, 0x1b, 0x71, 0x18, 0x57, 0xa7, 0xed, 0x78, 0x0d, 0x61, 0x3d, 0x08, 0x91, 0xe1, 0x65,
0x09, 0xff, 0xf9, 0x23, 0xbe, 0x71, 0x3d, 0x19, 0xda, 0xa2, 0x45, 0x21, 0x92, 0x58, 0x73, 0x9d,
0xd5, 0xd7, 0xd5, 0xb0, 0xe3, 0xc7, 0x42, 0x52, 0xf7, 0x61, 0xaa, 0xef, 0x07, 0x2d, 0xaf, 0x43,
0xeb, 0x8d, 0xad, 0x8f, 0xc0, 0x6f, 0x5c, 0x6f, 0xdd, 0x44, 0x7f, 0x81, 0xb1, 0xf1, 0xf9, 0xd5,
0x9e, 0xdc, 0x21, 0x7d, 0x9a, 0x2e, 0x0d, 0xa2, 0x7a, 0xe7, 0xea, 0xa3, 0xd4, 0xca, 0xaf, 0xc8,
0x36, 0xca, 0xf3, 0x6d, 0x7a, 0x09, 0xaa, 0x9c, 0x4d, 0xb2, 0xff, 0xfe, 0x98, 0x4d, 0x64, 0xa9,
0x32, 0xe0, 0xbc, 0x94, 0xe7, 0x00, 0x08, 0xf8, 0xdd, 0x08, 0x18, 0x9b, 0xf5, 0xa1, 0x16, 0x73,
0x03, 0x31, 0x2b, 0x44, 0xb5, 0x96, 0x87, 0xa3, 0xae, 0x08, 0x90, 0x05, 0xa9, 0x7c, 0xa7, 0x13,
0xe5, 0xf8, 0xf9, 0xac, 0xc0, 0xb1, 0x7d, 0xf1, 0x2f, 0xc6, 0x5d, 0x0b, 0x38, 0xd9, 0xae, 0xaa,
0x43, 0x43, 0xf7, 0xa2, 0x46, 0xd2, 0x0b, 0x99, 0x72, 0x76, 0x93, 0xe5, 0x14, 0x11, 0x32, 0x9a,
0x41, 0xb6, 0x92, 0xb7, 0x40, 0xf6, 0xe7, 0xeb, 0xbd, 0xe7, 0xa0, 0x96, 0x85, 0x38, 0x52, 0xd1,
0x23, 0x27, 0xc0, 0xbb, 0x5c, 0x0a, 0xe3, 0x96, 0xe8, 0x49, 0xfb, 0x5b, 0x20, 0x63, 0x85, 0x4d,
0x43, 0xad, 0x06, 0x3a, 0x33, 0xf9, 0x2c, 0x64, 0x36, 0xe7, 0x46, 0xe9, 0xd1, 0x7b, 0x1f, 0xb2,
0x98, 0x36, 0x1a, 0xb6, 0x18, 0xc4, 0x18, 0x53, 0x54, 0x6b, 0xe6, 0x9f, 0xf7, 0x05, 0x96, 0x4c,
0x01, 0x8d, 0x93, 0x0c, 0x60, 0x93, 0x25, 0xb6, 0xb5, 0xb5, 0x1f, 0x90, 0xaa, 0xb8, 0x67, 0xaa,
0x49, 0x57, 0xb7, 0x98, 0x18, 0xb4, 0x42, 0x54, 0x5f, 0x2a, 0x46, 0x71, 0x94, 0x4c, 0xfa, 0x83,
0x39, 0x62, 0x6d, 0x13, 0x7d, 0x92, 0xaa, 0xf2, 0xd3, 0xa5, 0x6d, 0x3a, 0x60, 0x3c, 0x11, 0xcf,
0xf8, 0xb1, 0x9a, 0xad, 0x62, 0x9e, 0xba, 0x89, 0x0c, 0xe1, 0x7b, 0x9f, 0xd2, 0x11, 0x6f, 0xc3,
};
uint8_t conv_out_CIF2[1539] = {
0xf9, 0x49, 0xbd, 0x49, 0x49, 0x9d, 0xd2, 0x69, 0x2b, 0x02, 0xf2, 0xf2, 0x04, 0x2f, 0x2d, 0x29,
0x06, 0xdd, 0x26, 0x92, 0xbf, 0xb4, 0x2f, 0x02, 0x26, 0x4b, 0x9b, 0x0d, 0x49, 0x9f, 0x2d, 0x09,
0x92, 0x69, 0xf2, 0x29, 0x29, 0xd2, 0x92, 0x9d, 0xd0, 0x96, 0xbd, 0x90, 0x9b, 0x00, 0x22, 0x92,
0x92, 0x4b, 0x6f, 0x20, 0x6d, 0x0b, 0x42, 0x06, 0xff, 0xbb, 0x94, 0x60, 0x9b, 0x0f, 0xb6, 0xf0,
0x0f, 0x6d, 0xd2, 0x69, 0xdd, 0xd0, 0x40, 0xfb, 0x99, 0xd2, 0xbd, 0x92, 0x6b, 0x0d, 0xb0, 0x20,
0xbb, 0xb4, 0xfb, 0x4d, 0x92, 0x6b, 0xf4, 0x00, 0xdb, 0x2d, 0xf2, 0x2b, 0xd9, 0xdf, 0x0f, 0x4d,
0xbf, 0x9b, 0xd9, 0xff, 0x94, 0x94, 0xb6, 0x24, 0x40, 0xd9, 0x0b, 0x40, 0x0f, 0x4d, 0xbf, 0x6d,
0xf2, 0x0b, 0xb4, 0xdb, 0xd6, 0x4b, 0x94, 0x96, 0x49, 0xb2, 0xdd, 0x2b, 0xf9, 0x44, 0x20, 0x99,
0x26, 0x90, 0xb9, 0x64, 0x94, 0xb9, 0xbf, 0x40, 0xfb, 0x6f, 0x0f, 0x6d, 0x2b, 0x2f, 0x0d, 0x44,
0x02, 0x0b, 0x42, 0x06, 0xff, 0xb4, 0xf9, 0x44, 0x20, 0x99, 0x26, 0x66, 0x6b, 0x2f, 0xdb, 0xfb,
0x42, 0xf0, 0xd4, 0x40, 0x2f, 0x20, 0xb4, 0x20, 0x60, 0x99, 0xf0, 0xd6, 0x49, 0x9d, 0x24, 0x4d,
0xbd, 0x6b, 0x22, 0xbf, 0x94, 0x4d, 0x92, 0x92, 0xbd, 0x4b, 0xb9, 0x90, 0xb6, 0x06, 0xdd, 0x26,
0x64, 0x9b, 0xd4, 0x6d, 0xdf, 0xfb, 0x96, 0xbf, 0x60, 0x96, 0x64, 0x4d, 0x9d, 0x09, 0xb2, 0x04,
0xf6, 0xf0, 0x2f, 0xf9, 0x9f, 0x02, 0xf0, 0x02, 0x06, 0xdf, 0x20, 0xb4, 0x20, 0x96, 0x4b, 0xb4,
0xf4, 0x20, 0xb9, 0xb2, 0xdd, 0xdd, 0x2b, 0x00, 0xfb, 0xb6, 0xdd, 0xff, 0xb9, 0x6b, 0x00, 0x22,
0x64, 0x40, 0xf6, 0x0b, 0x99, 0x2b, 0xfb, 0xbb, 0x40, 0xd6, 0x69, 0x09, 0x9f, 0x0d, 0x92, 0xb2,
0xdf, 0xdb, 0xfb, 0xb4, 0xdb, 0xd6, 0x4b, 0x9b, 0xfb, 0x94, 0x40, 0xf9, 0x66, 0x44, 0x2f, 0x0d,
0xbd, 0x4b, 0xb9, 0x9f, 0xd4, 0x4f, 0x42, 0xfd, 0x46, 0xf2, 0xff, 0x96, 0x6b, 0xd9, 0xff, 0x6d,
0xd2, 0x69, 0x24, 0x96, 0x66, 0xb2, 0x0b, 0x62, 0x6b, 0xfb, 0x62, 0x6b, 0xf4, 0xf9, 0x9d, 0x0b,
0xbb, 0xb6, 0x04, 0xdb, 0x0f, 0x60, 0x40, 0x2d, 0x26, 0x64, 0x62, 0x9d, 0x29, 0xdf, 0xf9, 0x66,
0xbd, 0x9f, 0xf6, 0xd2, 0x44, 0x22, 0x9f, 0xf6, 0xdd, 0xdf, 0x2d, 0xd0, 0x40, 0x02, 0x26, 0x4b,
0x6d, 0xdf, 0xf4, 0x02, 0x2b, 0xd9, 0x26, 0x46, 0xf0, 0xf6, 0xd2, 0x44, 0xdb, 0x20, 0x96, 0xb2,
0x04, 0x0f, 0x4f, 0x4f, 0x60, 0x96, 0x9d, 0xfd, 0x66, 0x66, 0xb2, 0xf2, 0x24, 0x42, 0x26, 0x6b,
0x00, 0xdb, 0x22, 0x66, 0x46, 0xdf, 0xf9, 0x69, 0x29, 0x0b, 0xb6, 0x24, 0xb9, 0x69, 0xff, 0x4d,
0x46, 0x2b, 0xd4, 0x4d, 0x4b, 0xb9, 0x69, 0xff, 0xbb, 0x9b, 0xf4, 0xf6, 0x09, 0x9f, 0x0d, 0x6b,
0x02, 0xdd, 0x04, 0x0f, 0xb9, 0x92, 0xb0, 0xd9, 0x0b, 0x4f, 0x94, 0x4d, 0x6b, 0x22, 0xb0, 0xf9,
0x69, 0x29, 0x0b, 0xb9, 0x46, 0xf0, 0xf9, 0xbf, 0x99, 0x26, 0x90, 0xb9, 0x9d, 0x2b, 0xd6, 0x44,
0xf9, 0xbd, 0x69, 0xdd, 0xdf, 0x22, 0x44, 0x2d, 0x0b, 0x94, 0xb9, 0x49, 0x92, 0x49, 0x9f, 0xd4,
0x4f, 0x4d, 0x69, 0xd2, 0xbd, 0x6b, 0x2d, 0xdd, 0xdd, 0xdd, 0xd2, 0x46, 0x2b, 0xd4, 0x42, 0xd0,
0xb6, 0xdf, 0x0f, 0x4d, 0x46, 0xd2, 0x92, 0x6b, 0x02, 0x2b, 0xd6, 0x44, 0xf9, 0xb2, 0x04, 0x00,
0x22, 0x9d, 0xff, 0x96, 0x9d, 0xf2, 0x04, 0x2f, 0x22, 0x44, 0x2d, 0xfd, 0xbf, 0xbb, 0x42, 0x26,
0x6b, 0x00, 0xdb, 0xd4, 0x4d, 0x4b, 0xb9, 0x90, 0xb9, 0x64, 0x62, 0x9d, 0x29, 0x29, 0xd2, 0x9d,
0xf0, 0x02, 0x06, 0xdf, 0xd9, 0xf2, 0x06, 0x29, 0x04, 0xdb, 0xf6, 0xdf, 0xd6, 0x69, 0x06, 0x0b,
0x96, 0x46, 0x26, 0xbf, 0xb9, 0x4b, 0x9b, 0xfb, 0x6d, 0x09, 0xbd, 0x69, 0xd2, 0x4b, 0x4f, 0xbb,
0xbb, 0x60, 0xb4, 0x00, 0x02, 0xff, 0x60, 0xb9, 0x6b, 0xf9, 0x9d, 0xf2, 0xfd, 0x9f, 0x2f, 0x0f,
0xbb, 0x94, 0x60, 0x94, 0x62, 0x92, 0x4b, 0x96, 0x90, 0x96, 0x92, 0x90, 0xb4, 0xf9, 0xbd, 0x66,
0x49, 0xbd, 0xbf, 0x62, 0x9f, 0xd6, 0xbf, 0x4f, 0x60, 0x96, 0x92, 0x66, 0x90, 0x60, 0x4f, 0xb9,
0xb2, 0x24, 0x94, 0x6f, 0x0f, 0x9b, 0xf6, 0xff, 0xb4, 0xf6, 0x29, 0xfd, 0x6b, 0xf4, 0xf6, 0xff,
0x42, 0x2b, 0x00, 0x02, 0x06, 0xd0, 0x42, 0xf2, 0xdd, 0x0b, 0x9b, 0x2d, 0xd2, 0x49, 0x46, 0xff,
0x9b, 0xf6, 0x06, 0x04, 0xfb, 0x9b, 0xd4, 0x9b, 0xfb, 0x9b, 0x22, 0x46, 0xd2, 0x9d, 0x06, 0xdf,
0xd6, 0x9f, 0x22, 0x64, 0x40, 0xf9, 0x9f, 0x0d, 0x64, 0x99, 0xdd, 0x26, 0x92, 0x46, 0x04, 0xdb,
0x0f, 0x6f, 0x2d, 0x09, 0x6b, 0x2f, 0xd4, 0x6f, 0xd6, 0x46, 0x09, 0xbf, 0x60, 0x96, 0x6b, 0x2f,
0x22, 0xbd, 0x64, 0x4f, 0x62, 0x9f, 0xd9, 0xd2, 0x6b, 0x22, 0xbf, 0x6d, 0xf2, 0xf2, 0x04, 0x20,
0xb9, 0x44, 0xf6, 0xd0, 0xb4, 0x2f, 0x0d, 0x44, 0x02, 0xf2, 0xfd, 0x90, 0x42, 0x24, 0x62, 0xb2,
0x29, 0x09, 0xbf, 0x60, 0x99, 0x06, 0xfd, 0x44, 0x0d, 0x90, 0xbb, 0x6d, 0xd0, 0x60, 0x99, 0x09,
0x69, 0x29, 0x0b, 0x4f, 0x9b, 0xd9, 0x06, 0xd2, 0xb2, 0x09, 0x9d, 0xf2, 0xf2, 0x0b, 0x4d, 0x92,
0x6b, 0x02, 0x2b, 0x20, 0x60, 0x99, 0x06, 0xfd, 0x4b, 0x60, 0x42, 0xdd, 0xdd, 0xdd, 0xdd, 0xd2,
0xbf, 0x94, 0x42, 0xff, 0xb9, 0x9d, 0x2b, 0x20, 0x99, 0x26, 0x9f, 0xdb, 0xd4, 0xb4, 0x02, 0x0b,
0xb4, 0xdb, 0x2f, 0x0d, 0x4b, 0x6f, 0xd6, 0x46, 0x06, 0x24, 0x60, 0xbb, 0x62, 0xbd, 0x4b, 0x4f,
0xb4, 0xd9, 0x29, 0xd2, 0x92, 0x64, 0x6f, 0x00, 0x00, 0x00, 0xf6, 0xdd, 0xd0, 0xb9, 0xbd, 0x49,
0xbf, 0x4f, 0x6f, 0x02, 0x09, 0xbd, 0x69, 0xdd, 0x29, 0xff, 0x9b, 0x0f, 0x40, 0x22, 0xb2, 0x06,
0xff, 0x42, 0x2b, 0xf6, 0x26, 0x66, 0x6b, 0xd6, 0x9d, 0xdd, 0xfd, 0x49, 0x9f, 0x22, 0x92, 0x9d,
0xdf, 0xfb, 0x6f, 0xf9, 0xb0, 0x02, 0xdf, 0xf4, 0x02, 0x24, 0xb4, 0x0d, 0x66, 0x66, 0xb2, 0xf2,
0x24, 0xbb, 0x96, 0x69, 0x26, 0x9f, 0xd4, 0xb9, 0x66, 0x6b, 0xd6, 0x64, 0x94, 0x4f, 0x9b, 0x20,
0xb6, 0xd0, 0x62, 0x9f, 0xd6, 0x46, 0x06, 0xdd, 0xdf, 0x22, 0x44, 0x22, 0x9f, 0x00, 0x0f, 0x62,
0x49, 0x66, 0x9d, 0x0b, 0xbb, 0xb6, 0x04, 0xd4, 0x62, 0x44, 0xfb, 0x4d, 0x92, 0x6b, 0x02, 0x2b,
0xd6, 0xbd, 0x46, 0x24, 0xb6, 0x04, 0x22, 0x49, 0xbf, 0xb9, 0xbd, 0x46, 0xdd, 0x09, 0x92, 0x69,
0xf2, 0xdf, 0xfb, 0x6f, 0xf6, 0x24, 0x99, 0x04, 0x0d, 0x46, 0x04, 0xdb, 0x00, 0xf4, 0xd4, 0x9b,
0x02, 0x24, 0xbb, 0x60, 0x42, 0x24, 0x9b, 0xf4, 0x00, 0xd4, 0xb6, 0xf2, 0x09, 0xbd, 0x69, 0x24,
0x99, 0xf2, 0x29, 0x26, 0xbf, 0x4f, 0x60, 0x6f, 0x2d, 0x09, 0x92, 0x9f, 0x20, 0x6d, 0xf2, 0xf2,
0x0b, 0xb4, 0x22, 0x66, 0xbf, 0x96, 0xbd, 0x66, 0x49, 0xb2, 0x2b, 0x00, 0xfb, 0x4f, 0x9b, 0x2f,
0x22, 0x44, 0x2d, 0x04, 0xf6, 0x09, 0x66, 0x4b, 0x42, 0x29, 0x06, 0x24, 0x6f, 0xd9, 0xdd, 0xf0,
0xd4, 0xb6, 0xfd, 0x92, 0xbd, 0xbd, 0x9d, 0xff, 0x96, 0x64, 0xb4, 0xdb, 0xd6, 0xbd, 0x46, 0x24,
0x4f, 0x42, 0xfd, 0xbf, 0x4d, 0x90, 0x6d, 0xdd, 0xf2, 0x2b, 0x2f, 0x0d, 0x44, 0xfb, 0x42, 0x09,
0x64, 0xb4, 0x22, 0x90, 0x9b, 0xf6, 0x09, 0x90, 0x96, 0x64, 0xb4, 0xd4, 0xb4, 0x0d, 0x66, 0x9f,
0x02, 0x09, 0xbd, 0x9f, 0xf9, 0x49, 0x44, 0x0f, 0x99, 0xf0, 0xd9, 0xd2, 0x6b, 0x22, 0xbf, 0x62,
0x9f, 0x2f, 0x0f, 0xb4, 0x00, 0xfb, 0xb6, 0xd2, 0x64, 0x4f, 0x9b, 0xd9, 0x06, 0xd2, 0x4b, 0xb9,
0x66, 0x6b, 0xd6, 0x92, 0xbf, 0xb4, 0xd9, 0x26, 0x49, 0x92, 0xbf, 0xbb, 0xbb, 0x96, 0x66, 0xb2,
0xf2, 0x24, 0x42, 0xd0, 0x40, 0x0d, 0xbd, 0xbd, 0x6b, 0xd4, 0x94, 0x6f, 0xf6, 0x24, 0x6f, 0x2f,
0xf9, 0x69, 0x29, 0xfd, 0x64, 0x6f, 0xf6, 0x2b, 0x0d, 0x9f, 0xd6, 0xbf, 0xb6, 0x29, 0x24, 0xb9,
0x69, 0xf0, 0x20, 0x9b, 0xd6, 0x9d, 0x24, 0x4d, 0xbd, 0x6b, 0x22, 0xb0, 0xf9, 0x69, 0x26, 0x69,
0x06, 0xfd, 0xb2, 0x29, 0xff, 0x9b, 0x0f, 0x4f, 0xb6, 0x26, 0x49, 0x92, 0xb0, 0x20, 0xb4, 0x20,
0x99, 0xd0, 0x4d, 0x66, 0x46, 0xd0, 0x62, 0x66, 0x66, 0xbd, 0x90, 0x9b, 0x0f, 0x4f, 0xb6, 0xd0,
0x9b, 0x20, 0x40, 0x02, 0x26, 0xb2, 0xd2, 0x46, 0x2b, 0xd4, 0xbb, 0x99, 0x04, 0xf4, 0x00, 0xdb,
0x22, 0x66, 0xbf, 0x60, 0x99, 0xf0, 0xd9, 0xd2, 0x9d, 0x09, 0xb2, 0x04, 0xf6, 0xf0, 0x20, 0x94,
0x4d, 0x9d, 0x09, 0xb2, 0xfd, 0x46, 0x0b, 0x40, 0xf6, 0x04, 0xfb, 0x9b, 0x22, 0xb0, 0xf6, 0xfd,
0x44, 0xfb, 0x42, 0xff, 0xb6, 0x09, 0xbf, 0x60, 0x60, 0xb9, 0x6b, 0xf9, 0x9d, 0xfd, 0x66, 0x90,
0x60, 0xb9, 0x6b, 0x0f, 0x4f, 0x40, 0xf4, 0x02, 0xd2, 0x90, 0x9b, 0x0f, 0xb9, 0x92, 0xbf, 0xb4,
0x20, 0x99, 0xdf, 0x20, 0x42, 0x04, 0xf9, 0x92, 0x90, 0x4d, 0x46, 0xdd, 0x09, 0x64, 0x4d, 0x6b,
0x2d, 0xdd, 0x2b, 0x00, 0x0d, 0x64, 0x60, 0x62, 0x49, 0x9f, 0xd4, 0xb9, 0x9f, 0xdb, 0xdb, 0x2f,
0xfb, 0x6f, 0x00, 0x0f, 0x9b, 0x0f, 0x4f, 0x4f, 0x60, 0x6f, 0xdb, 0xdb, 0x2f, 0xfb, 0x96, 0xb0,
0xf4, 0xf4, 0x0f, 0xb6, 0x06, 0xd2, 0x44, 0xdb, 0x2f, 0x0d, 0xbd, 0x4b, 0xb9, 0x69, 0x09, 0x90,
0x96, 0x92, 0x66, 0x69, 0x26, 0x69, 0x09, 0x69, 0xd0, 0x42, 0x0b, 0x9b, 0x22, 0x46, 0x2b, 0x22,
0x69, 0x2b, 0x02, 0xf2, 0xf2, 0xfd, 0x9f, 0xd6, 0x49, 0x6b, 0x00, 0x22, 0x64, 0x4f, 0x6d, 0xf2,
0x0b, 0xb4, 0xd4, 0x4d, 0x4b, 0x40, 0x2f, 0xd9, 0x0b, 0x40, 0xf9, 0x9f, 0xfb, 0xb6, 0xdd, 0xff,
0xb6, 0xff, 0x9b, 0x0f, 0x40, 0xd4, 0x96, 0x66, 0xb2, 0xf2, 0xd2, 0x69, 0xd2, 0x4b, 0x40, 0x20,
0x42, 0xfd, 0x46, 0x04, 0xd4, 0x62, 0x44, 0x02, 0x0b, 0xb4, 0x2d, 0x04, 0x00, 0x22, 0x92, 0x6b,
0xf4, 0x00, 0xd4, 0x4f, 0x42, 0xf2, 0x2b, 0x2f, 0x02, 0x26, 0xbd, 0xbf, 0x6d, 0x04, 0xd9, 0x09,
0xb0, 0x02, 0x29, 0x29, 0x24, 0xb9, 0x90, 0x40, 0x22, 0xb2, 0x06, 0x09, 0x66, 0xb2, 0xf2, 0x2b,
0x20, 0x6f, 0xf4, 0xdb, 0x0f, 0x6f, 0xdb, 0xd4, 0xb4, 0x02, 0xf2, 0xf2, 0xfd, 0x90, 0xbb, 0x62,
0x4b, 0x96, 0x66, 0x44, 0xd9, 0xd0, 0x94, 0xbb, 0x40, 0xd6, 0x69, 0x09, 0x66, 0x44, 0xd9, 0xd0,
0x94, 0x42, 0xff, 0xb6, 0xf0, 0xf9, 0x49, 0x4b, 0x94, 0x60, 0x6d, 0xdd, 0x0b, 0x62, 0x9d, 0x26,
0xb2, 0xdd, 0xd2, 0x49, 0xb0, 0xd4, 0x99, 0x04, 0xf4, 0x00, 0x2d, 0x09, 0x9d, 0xf2, 0xfd, 0x66,
0x69, 0x26, 0x90, 0x40, 0xdb, 0xfb, 0x4d, 0x64, 0x4f, 0x62, 0x9f, 0x20, 0x6d, 0x04, 0x2f, 0x22,
0x44, 0x22, 0x66, 0xb0, 0x02, 0x29, 0x26, 0x49, 0x92, 0x46, 0x0b, 0x40, 0x00, 0xd9, 0xd2, 0x6b,
0x2d, 0x2b, 0xf9, 0x4b, 0x42, 0x26, 0x9d, 0xdd, 0xfd, 0x49, 0x69, 0xff, 0x42, 0x24, 0x94, 0x96,
0xb0, 0xfb, 0x6f,
};



int do_test(uint8_t *input, int input_size, uint8_t *output, int output_size)
{

	int not_ok = 0;
	/**************************************************************************************
	 * HW Implementation
	 **************************************************************************************/
    hls::stream<u8stream> data_in;
    hls::stream<u8stream> data_out;

    u8stream var;
    int rules_num=0;

    uint8_t *out2 = (uint8_t *) calloc(1, output_size);

    do_convolution(input, input_size, out2, output_size);

    if(memcmp(output, out2, output_size)) {
    	fprintf(stderr, "[SOFT] mem is different:\n");
    	for(int i =0; i< output_size; i++) {
    		if(output[i] != out2[i])
    			fprintf(stderr, "[SOFT] mem[%d]: %02x != %02x\n", i, output[i], out2[i]);
    	}
        return 1;
    } else {
    	fprintf(stderr, "[SOFT] mem ok\n");
        //return 0;
    }


  memset(out2, 0x00, output_size);

    ap_uint<2> debug = 0;

	var.last = 0;
	var.data = 0xF1; //pass to next block
	data_in.write(var);

	//SEND FC
//1st FIC:			{0x66, 0x8c, 0x8b, 0x85};
	var.data = 0x9b;
	data_in.write(var);
	var.data = 0x8c;
	data_in.write(var);
	var.data = 0x2b;
	data_in.write(var);
	var.data = 0x85;
	data_in.write(var);


	for(int i=0;i<input_size;i++) {
		var.data = input[i];
		var.last = (i==(input_size-1)) ? 1 : 0;
		data_in.write(var);
	}

	convolution_dbg(data_in, data_out, &debug);

	int read_size = data_out.size();
	if(read_size > 2) {
		fprintf(stderr, "[FIC HARD] CONVOLUTED read[%d]: \n", read_size);
		u8stream var2;
		var2=data_out.read();
		fprintf(stderr, "[FIC HARD] CONVOLUTED CIF/FIC id: 0x%02x\n", (uint8_t) var2.data);
		read_size-=1;

#if 1
		fprintf(stderr, "[FIC HARD] CONVOLUTED FC = 0x");

		for(int y=0; y<4;y++) {
			var2=data_out.read();
			fprintf(stderr, "%02x", (uint8_t) var2.data);
			read_size-=1;
		}
		fprintf(stderr, "\n");
#endif

		int readed=0;
		do {
			var2=data_out.read();
			fprintf(stderr, "[%02x]%s, ", (int)var2.data, var2.last ? "L":"");
			if((readed+1)%16==0) fprintf(stderr, "\n");
			read_size--;

			if(readed<output_size)
				out2[readed] = var2.data;
			else
				fprintf(stderr, "UNNEEDED!!!\n");

			readed++;
		} while (read_size);
		fprintf(stderr, "\nreaded total: %d\n", readed);
	}

	if(memcmp(output, out2, output_size)) {
	    	fprintf(stderr, "[FIC HARD] mem is different:\n");
	    	for(int i =0; i< sizeof(out2); i++) {
	    		if(output[i] != out2[i])
	    			fprintf(stderr, "[FIC HARD] mem[%d]: %02x != %02x\n", i, output[i], out2[i]);
	    	}
	    	free(out2);
	        return 1;
	} else {
		fprintf(stderr, "[FIC HARD] mem ok\n");
		free(out2);
		return 0;
	}
}





int main()
{
	int ret=0;

	 ret = do_test(conv_in_FIC1, sizeof(conv_in_FIC1), conv_out_FIC1, sizeof(conv_out_FIC1));
	 if(ret)
		 return ret;

	 ret = do_test(conv_in_FIC2, sizeof(conv_in_FIC2), conv_out_FIC2, sizeof(conv_out_FIC2));
	 if(ret)
		 return ret;

	 ret = do_test(conv_in_CIF1, sizeof(conv_in_CIF1), conv_out_CIF1, sizeof(conv_out_CIF1));
	 if(ret)
		 return ret;

	 ret = do_test(conv_in_CIF2, sizeof(conv_in_CIF2), conv_out_CIF2, sizeof(conv_out_CIF2));
	 if(ret)
		 return ret;

	return ret;
}

