// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2014.1
// Copyright (C) 2014 Xilinx Inc. All rights reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

module uart_tx_src (
        ap_clk,
        ap_rst_n,
        output_V_V_din,
        output_V_V_full_n,
        output_V_V_write
);

parameter    ap_ST_INIT = 4'b0000;
parameter    ap_ST_st2_fsm_1 = 4'b1;
parameter    ap_ST_st3_fsm_2 = 4'b10;
parameter    ap_ST_st4_fsm_3 = 4'b11;
parameter    ap_ST_st5_fsm_4 = 4'b100;
parameter    ap_ST_st6_fsm_5 = 4'b101;
parameter    ap_ST_st7_fsm_6 = 4'b110;
parameter    ap_ST_st8_fsm_7 = 4'b111;
parameter    ap_ST_st9_fsm_8 = 4'b1000;
parameter    ap_ST_st10_fsm_9 = 4'b1001;
parameter    ap_ST_st11_fsm_10 = 4'b1010;
parameter    ap_ST_st12_fsm_11 = 4'b1011;
parameter    ap_ST_FINISH = 4'b1100;

input   ap_clk;
input   ap_rst_n;
output  [7:0] output_V_V_din;
input   output_V_V_full_n;
output   output_V_V_write;

reg[7:0] output_V_V_din;
reg output_V_V_write;
reg   [3:0] ap_CS_fsm = 4'b0000;
reg   [3:0] ap_NS_fsm;




/// the current state (ap_CS_fsm) of the state machine. ///
always @ (posedge ap_clk)
begin : ap_ret_ap_CS_fsm
    if (ap_rst_n == 1'b0) begin
        ap_CS_fsm <= ap_ST_INIT;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

/// output_V_V_din assign process. ///
always @ (output_V_V_full_n or ap_CS_fsm)
begin
    if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st12_fsm_11 == ap_CS_fsm))) begin
        output_V_V_din = 8'h8B;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st11_fsm_10 == ap_CS_fsm))) begin
        output_V_V_din = 8'h2A;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st9_fsm_8 == ap_CS_fsm))) begin
        output_V_V_din = 8'h12;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st8_fsm_7 == ap_CS_fsm))) begin
        output_V_V_din = 8'h0D;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st7_fsm_6 == ap_CS_fsm))) begin
        output_V_V_din = 8'h00;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st6_fsm_5 == ap_CS_fsm))) begin
        output_V_V_din = 8'h03;
    end else if (((~(output_V_V_full_n == 1'b0) & (ap_ST_st5_fsm_4 == ap_CS_fsm)) |
	               (~(output_V_V_full_n == 1'b0) & (ap_ST_st10_fsm_9 == ap_CS_fsm)))) begin
        output_V_V_din = 8'h01;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st4_fsm_3 == ap_CS_fsm))) begin
        output_V_V_din = 8'h06;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st3_fsm_2 == ap_CS_fsm))) begin
        output_V_V_din = 8'h62;
    end else if ((~(output_V_V_full_n == 1'b0) & (ap_ST_st2_fsm_1 == ap_CS_fsm))) begin
        output_V_V_din = 8'hB5;
    end else if (((ap_ST_INIT == ap_CS_fsm) & ~(output_V_V_full_n == 1'b0))) begin
        output_V_V_din = 8'h0A;
    end else begin
        output_V_V_din = 'bx;
    end
end

/// output_V_V_write assign process. ///
always @ (output_V_V_full_n or ap_CS_fsm)
begin
    if ((((ap_ST_INIT == ap_CS_fsm) & ~(output_V_V_full_n == 1'b0)) |
	    (~(output_V_V_full_n == 1'b0) & (ap_ST_st2_fsm_1 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st3_fsm_2 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st4_fsm_3 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st5_fsm_4 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st6_fsm_5 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st7_fsm_6 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st8_fsm_7 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st9_fsm_8 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st10_fsm_9 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st11_fsm_10 == ap_CS_fsm)) |
		 (~(output_V_V_full_n == 1'b0) & (ap_ST_st12_fsm_11 == ap_CS_fsm)))) begin
        output_V_V_write = 1'b1;
    end else begin
        output_V_V_write = 1'b0;
    end
end
always @ (output_V_V_full_n or ap_CS_fsm)
begin
    case (ap_CS_fsm)
        ap_ST_INIT : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end else begin
                ap_NS_fsm = ap_ST_INIT;
            end
        ap_ST_st2_fsm_1 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st3_fsm_2;
            end else begin
                ap_NS_fsm = ap_ST_st2_fsm_1;
            end
        ap_ST_st3_fsm_2 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st4_fsm_3;
            end else begin
                ap_NS_fsm = ap_ST_st3_fsm_2;
            end
        ap_ST_st4_fsm_3 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st5_fsm_4;
            end else begin
                ap_NS_fsm = ap_ST_st4_fsm_3;
            end
        ap_ST_st5_fsm_4 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st6_fsm_5;
            end else begin
                ap_NS_fsm = ap_ST_st5_fsm_4;
            end
        ap_ST_st6_fsm_5 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st7_fsm_6;
            end else begin
                ap_NS_fsm = ap_ST_st6_fsm_5;
            end
        ap_ST_st7_fsm_6 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st8_fsm_7;
            end else begin
                ap_NS_fsm = ap_ST_st7_fsm_6;
            end
        ap_ST_st8_fsm_7 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st9_fsm_8;
            end else begin
                ap_NS_fsm = ap_ST_st8_fsm_7;
            end
        ap_ST_st9_fsm_8 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st10_fsm_9;
            end else begin
                ap_NS_fsm = ap_ST_st9_fsm_8;
            end
        ap_ST_st10_fsm_9 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st11_fsm_10;
            end else begin
                ap_NS_fsm = ap_ST_st10_fsm_9;
            end
        ap_ST_st11_fsm_10 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_st12_fsm_11;
            end else begin
                ap_NS_fsm = ap_ST_st11_fsm_10;
            end
        ap_ST_st12_fsm_11 : 
            if (~(output_V_V_full_n == 1'b0)) begin
                ap_NS_fsm = ap_ST_FINISH;
            end else begin
                ap_NS_fsm = ap_ST_st12_fsm_11;
            end
        ap_ST_FINISH : 
            ap_NS_fsm = ap_ST_FINISH;
        default : 
            ap_NS_fsm = 'bx;
    endcase
end


endmodule //convolution

